import numpy as np

# (13, 20)
# (20, 20)
# (20, 3)

# (13, 20)
P1 = np.load( "W1.bin.npy" ) 

# (20, 20)
P2 = np.load( "W2.bin.npy" ) 

# (20, 3)
P3 = np.load( "W3.bin.npy" ) 


# Los sesgos
S1 = np.load( "S1.bin.npy" ) 
S2 = np.load( "S2.bin.npy" ) 
S3 = np.load( "S3.bin.npy" ) 

# La función de activación a la salida
# softmax

# El modelo realiza:
# En la primera capa
#      u = suma entradas_1 * pesos_1 + sesgo_1
#                   1x13      13x20      1x20 
#      y = relu( u )
#
# En la segunda capa
#      u = suma entradas_2 * pesos_2 + sesgo_2
#                    1x20      20x20     1x20 
#      y = relu( u )
# 
# En la tercera capa
#      u = suma entradas_2 * pesos_2 + sesgo_2
#                    1x20      20x3      1x3 
#      u \in 1x3
#
#  softmax( z ) = softmax( z - max(z) )
#  zmax = max(u)
#  u = u - zmax
#      den = suma (exp( u ))
#      s1 = exp(z0)/u 
#      s2 = exp(z1)/u 
#      s3 = exp(z2)/u

# Suponemos que el "Entradas" es una matriz
# de tamaño n x características
def evalua( Entradas ) : 
	m, n = Entradas.shape

	# Realizamos los cálculos en la primera capa
	# Entrada n x 2
	# Capa1   2 x 7
	U1 = Entradas @ P1 + S1
	# n x 7
	n, m = U1.shape
	i = 0
	while i < n :
		j = 0
		while j < m :
			U1[i, j] = max( 0, U1[i,j] )
			j += 1
		i += 1

	# U2 es de tamaño 7 x 1
	# Capa2 es de tamaño 7x7
	U2 = U1 @ P2 + S2
	n, m = U2.shape
	i = 0
	while i < n :
		j = 0
		while j < m :
			U2[i, j] = max( 0, U2[i,j] )
			j += 1
		i += 1

	# U3 es la tercera capa
	U3 = U2 @ P3 + S3

	#  softmax( z ) = softmax( z - max(z) )
	zmax = np.max(U3, axis=1)
	# print( "U3", U3.shape )
	# print( "zmax", zmax.shape )
	zmax = zmax.reshape( (-1,1) )
	U3 = U3 - zmax
	den = np.sum( np.exp( U3 ))
	U3 = np.exp(U3) / den

	# U3 \in 45 x 3

	vr = np.argmax( U3, axis=1 )
	# print( "vr:", vr.shape )

	return vr 
