# Un clasificador con frontera no lineal
# hecho con redes de perceptrones
# 14.03.2022
# 05.09.2023
# Fraga
import numpy as np
import sklearn.datasets as samples_generator
from sklearn import model_selection
from sklearn import metrics
from sklearn.neural_network import MLPClassifier
from sklearn.model_selection import KFold
from sklearn.model_selection import cross_val_score
# import matplotlib.pyplot as plt

# Leo los datos de entrada del archivo "circulos.csv"
D = np.loadtxt( "wineMinMax.csv", delimiter=',' )
X = D[:,0:13]
y = D[:,13]
print( X.shape )
print( y.shape )

rng = np.random.RandomState(0)
cv = KFold(shuffle=True, random_state=rng)

red = MLPClassifier(solver='adam', alpha=1e-3, hidden_layer_sizes=(20,20,), random_state=2, max_iter=500)
# red = MLPClassifier(solver='lbfgs', alpha=1e-3, hidden_layer_sizes=(7,7,), random_state=2, max_iter=500)
# red = MLPClassifier(solver='adam', alpha=1e-1, hidden_layer_sizes=(7,7,3), random_state=4, max_iter=400)

exactitud = cross_val_score( red, X, y, cv=cv )

print( exactitud )
print( "Media:", np.mean(exactitud) )
print( "Des. Est.:", np.std(exactitud) )


# print( red.get_params() )
# for coef in red.coefs_ :
# 	print( coef.shape )

# for coef in red.coefs_ :
#  	print( coef )

# print( type(red) )
# print( red.intercepts_ )
# print( red.out_activation_ )

# Graficamos los resultados

# fig, [ex1, ex2] = plt.subplots( 1, 2 )

# Los datos de entrenamiento
# ex1.scatter( Xentrena[:,0], Xentrena[:,1], c=yentrena )
# ex1.set_aspect( 1.0 )
# xmin, xmax = ex1.get_xlim( )
# ymin, ymax = ex1.get_ylim( )

# Los datos de prueba
# ex2.scatter( Xprueba[:,0], Xprueba[:,1], c=yprueba )
# ex2.set_aspect( 1.0 )
# ex2.set_xlim( xmin, xmax )
# ex2.set_ylim( ymin, ymax )

# plt.show( )
