# Un clasificador con frontera no lineal
# hecho con redes de perceptrones
# 15.09.2023
# Fraga
import numpy as np
import sklearn.datasets as samples_generator
from sklearn import model_selection
from sklearn import metrics
from sklearn.neural_network import MLPClassifier

# Leo los datos de entrada del archivo "circulos.csv"
D = np.loadtxt( "wineMinMax.csv", delimiter=',' )
print( D.shape )
X = D[:,0:13]
y = D[:,13]
print( X.shape )
print( y.shape )

# Separamos los datos de entrenamiento y de prueba
Xentrena, Xprueba, yentrena, yprueba = model_selection.train_test_split( X, y, random_state = 17 )

# np.savetxt( "Xprueba.txt", Xprueba )
# np.savetxt( "yprueba.txt", yprueba )

red = MLPClassifier(solver='adam', alpha=1e-3, hidden_layer_sizes=(20,20,), random_state=2, max_iter=500)
# red = MLPClassifier(solver='lbfgs', alpha=1e-3, hidden_layer_sizes=(7,7,), random_state=2, max_iter=500)
# red = MLPClassifier(solver='adam', alpha=1e-1, hidden_layer_sizes=(7,7,3), random_state=4, max_iter=400)

red.fit( Xentrena, yentrena )

ypredichas = red.predict( Xentrena )
exactitud = metrics.accuracy_score( yentrena, ypredichas )
print( "Entrenamiento:", exactitud )

ypredichas = red.predict( Xprueba )
e = metrics.accuracy_score( yprueba, ypredichas )

print( "Prueba:", e )

print( ypredichas )
n, = ypredichas.shape
i = 0
while i < n :
 	print( ypredichas[i] )
 	i += 1

print( red.get_params() )
for coef in red.coefs_ :
  	print( coef.shape )

# Guardamos los pesos en archivos binarios
# for coef in red.coefs_ :
#     	print( coef )
np.save( "W1.bin", red.coefs_[0] )
np.save( "W2.bin", red.coefs_[1] )
np.save( "W3.bin", red.coefs_[2] )

print( type(red) )
# print( red.intercepts_ )
np.save( "S1.bin", red.intercepts_[0] )
np.save( "S2.bin", red.intercepts_[1] )
np.save( "S3.bin", red.intercepts_[2] )
print( red.out_activation_ )

# Graficamos los resultados

# fig, [ex1, ex2] = plt.subplots( 1, 2 )

# Los datos de entrenamiento
# ex1.scatter( Xentrena[:,0], Xentrena[:,1], c=yentrena )
# ex1.set_aspect( 1.0 )
# xmin, xmax = ex1.get_xlim( )
# ymin, ymax = ex1.get_ylim( )

# Los datos de prueba
# ex2.scatter( Xprueba[:,0], Xprueba[:,1], c=yprueba )
# ex2.set_aspect( 1.0 )
# ex2.set_xlim( xmin, xmax )
# ex2.set_ylim( ymin, ymax )

# plt.show( )
